import express from "express";
import "express-async-errors";
import NodeCache from "node-cache";
declare type DistRecord = {
    integrity: string;
    tarball: string;
    fileCount: number;
    unpackedSize: number;
};
declare type PackageRecord = {
    name: string;
    version: string;
    dependencies?: Record<string, string>;
    devDependencies?: Record<string, string>;
    dist: DistRecord;
};
declare type PackagesRecord = {
    name: string;
    versions: Record<string, PackageRecord>;
};
interface OfflineMirrorRegistryProps {
    cache?: NodeCache;
    directory?: string;
    useHostname?: boolean;
}
declare class OfflineMirrorRegistry {
    private cache;
    private directory;
    private useHostname;
    constructor(props: OfflineMirrorRegistryProps);
    getPackages(dir: string, name: string): Promise<PackagesRecord | null>;
    getServer(): express.Express;
    transformName(name: string): string;
}
export { DistRecord, PackageRecord, PackagesRecord, OfflineMirrorRegistry };
